// GetColorProfiles.cpp
// w肳ꂽfBXvCɊ֘AtꂽJ[vt@Cꗗ擾B

//CN[h
#include <stdio.h>
#include <iostream>
#include <windows.h>
#include <shellapi.h>
#include <strsafe.h>
#include <icm.h>


//C
int main()
{
	//UnicodeR}hC
	LPWSTR* argvw;
	int argcw;
	argvw = CommandLineToArgvW(GetCommandLineW(), &argcw);
	if (NULL == argvw)
	{
		std::wcout << "ERROR:CommandLineToArgvW Failed" << std::endl;
		return 1;
	}


	//ϐ錾
	DISPLAY_DEVICE displayDevice = {};				//DISPLAY_DEVICE\
	displayDevice.cb = sizeof(DISPLAY_DEVICE);			//DISPLAY_DEVICE\̂̃TCY


	LPWSTR	deviceName = (LPWSTR)L"\\\\.\\DISPLAY1";		//ΏۃfoCXij^ԍj
	BOOL	usePerUserProfiles = true;				//ΏۃfoCX̃vt@CXR[v
	DWORD	profileListSize = 0;					//J[vt@CXgobt@TCY
	PBYTE	profileList;						//J[vt@CXgobt@|C^


	//`FbN
	//ߕs͎gpo͂ďI
	if (argcw <= 1 || argcw >= 4) {
		std::wcout << "w肳ꂽfBXvCɊ֘AtꂽJ[vt@Cꗗ擾܂B" << std::endl;
		std::wcout << "ftHgł́Ã݂XR[vݒɊÂĎ擾Ώۂ肳܂B" << std::endl << std::endl;
		std::wcout << "GetColorProfiles.exe foCX [/S | /U | /A]" << std::endl;
		std::wcout << "  foCX     Ώۂ̃foCXw肵܂B :\\\\.\\DISPLAY1" << std::endl;
		std::wcout << "  /S             ݂̐ݒlɂ炸AVXeŜ̐ݒ擾܂B" << std::endl;
		std::wcout << "  /U             ݂̐ݒlɂ炸A[U[Ƃ̐ݒ擾܂B" << std::endl;
		std::wcout << "  /A             VXeŜƁA[U[Ƃ̐ݒ擾܂B" << std::endl;
		std::wcout << "                 ɓvt@Co^ĂꍇAedďo͂\܂B" << std::endl;
		return 0;
	}


	//
	deviceName = argvw[1];	//foCX


	//fBXvC擾
	if (!EnumDisplayDevicesW(deviceName, 0, &displayDevice, EDD_GET_DEVICE_INTERFACE_NAME)) {
		/* G[ */
		std::wcout << "ERROR:Device Not Found" << std::endl;
		return 1;
	}


	//VXeXR[vw莞
	if (argcw == 3) {
		if (!wcscmp(L"/S", argvw[2])) {
			usePerUserProfiles = false;
		}

		if (!wcscmp(L"/A", argvw[2])) {
			usePerUserProfiles = false;
		}
	}
	else {
		//XR[vw莞݂͌̐ݒl
		if (!WcsGetUsePerUserProfiles(displayDevice.DeviceKey, CLASS_MONITOR, &usePerUserProfiles)) {
			/* G[*/
			std::wcout << "ERROR:WcsGetUsePerUserProfiles Failed" << std::endl;
			return 1;
		}
	}


	tagENUMTYPEW	enumtype = {};				 //tagENUMTYPEW\
	enumtype.dwSize = sizeof(tagENUMTYPEW);
	enumtype.dwVersion = ENUM_TYPE_VERSION;			//
	enumtype.dwFields = ET_DEVICENAME | ET_CLASS;
	enumtype.dwClass = CLASS_MONITOR;
	enumtype.pDeviceName = displayDevice.DeviceKey;


	//J[vt@CTCY擾
	if (!WcsEnumColorProfilesSize(
		(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
		&enumtype,
		&profileListSize
	)) {
		/* G[*/
		std::wcout << "ERROR:WcsEnumColorProfilesSize Failed" << std::endl;
		return 1;
	}


	//J[vt@Cobt@m
	profileList = (PBYTE)malloc(profileListSize);
	if (profileList == NULL) {
		/* ăG[ */
		std::wcout << "ERROR:Memory Allocation Error" << std::endl;
		return 1;
	}
	else {
		//J[vt@Cꗗ擾
		if (!WcsEnumColorProfiles(
			(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
			&enumtype,
			profileList,
			profileListSize,
			NULL
		)) {
			/* G[*/
			std::wcout << "ERROR:WcsEnumColorProfiles  Failed" << std::endl;
			return 1;
		}
	}

	//s؂ɂ
	for (unsigned int i = 0; i < (profileListSize - 2); i++) {
		//(16bitPʂňׁA2̔{͉Ȃ)
		if (!(i % 2)) {
			if (profileList[i] + (profileList[i + 1] << 8) == 0x0000)
				profileList[i] = 0x0A;
		}
	}


	//ʕ\
	std::wcout << "DeviceName:" << deviceName << std::endl;		//foCX

	if (usePerUserProfiles)						//XR[v
		std::wcout << "Scope:User" << std::endl;
	else
		std::wcout << "Scope:System" << std::endl;

	std::wcout << "Profiles:" << std::endl;				//vt@Cꗗ
	std::wcout << (LPWSTR)profileList;


	//擾͂x点
	if (!wcscmp(L"/A", argvw[2])) {
		usePerUserProfiles = true;

		//J[vt@CTCY擾
		if (!WcsEnumColorProfilesSize(
			(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
			&enumtype,
			&profileListSize
		)) {
			/* G[*/
			std::wcout << "ERROR:WcsEnumColorProfilesSize Failed" << std::endl;
			return 1;
		}


		//J[vt@Cobt@m
		profileList = (PBYTE)malloc(profileListSize);
		if (profileList == NULL) {
			/* ăG[ */
			std::wcout << "ERROR:Memory Allocation Error" << std::endl;
			return 1;
		}
		else {
			//J[vt@Cꗗ擾
			if (!WcsEnumColorProfiles(
				(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
				&enumtype,
				profileList,
				profileListSize,
				NULL
			)) {
				/* G[*/
				std::wcout << "ERROR:WcsEnumColorProfiles  Failed" << std::endl;
				return 1;
			}
		}

		//s؂ɂ
		for (unsigned int i = 0; i < (profileListSize - 2); i++) {
			//(16bitPʂňׁA2̔{͉Ȃ)
			if (!(i % 2)) {
				if (profileList[i] + (profileList[i + 1] << 8) == 0x0000)
					profileList[i] = 0x0A;
			}
		}

		std::wcout << (LPWSTR)profileList;
	}

	return 0;
}