// SetDefaultColorProfile.cpp
// w肳ꂽfBXvC̊̃J[vt@CύXB

//CN[h
#include <stdio.h>
#include <iostream>
#include <windows.h>
#include <shellapi.h>
#include <strsafe.h>
#include <icm.h>


//C
int main()
{
	//UnicodeR}hC
	LPWSTR* argvw;
	int argcw;
	argvw = CommandLineToArgvW(GetCommandLineW(), &argcw);
	if (NULL == argvw)
	{
		std::wcout << "ERROR:CommandLineToArgvW Failed" << std::endl;
		return 1;
	}


	//ϐ錾
	DISPLAY_DEVICE displayDevice = {};				//DISPLAY_DEVICE\
	displayDevice.cb = sizeof(DISPLAY_DEVICE);			//DISPLAY_DEVICE\̂̃TCY


	LPWSTR	deviceName = (LPWSTR)L"\\\\.\\DISPLAY1";		//ΏۃfoCXij^ԍj
	BOOL	usePerUserProfiles = true;				//ΏۃfoCX̃vt@CXR[v
	DWORD	profileNameSize = 0;					//J[vt@Cobt@TCY
	LPWSTR	profileName;						//J[vt@Cobt@|C^


	//`FbN
	//ߕs͎gpo͂ďI
	if (argcw <= 2 || argcw >= 5) {
		std::wcout << "w肳ꂽfBXvC̊̃J[vt@CύX܂B" << std::endl << std::endl;
		std::wcout << "SetDefaultColorProfile.exe foCX vt@C [/S]" << std::endl;
		std::wcout << "  foCX     Ώۂ̃foCXw肵܂B :\\\\.\\DISPLAY1" << std::endl;
		std::wcout << "  vt@C ݒ肷ICMvt@Cw肵܂B" << std::endl;
		std::wcout << "  /S             [U[ƂłȂAVXeŜ̊lƂĐݒ肵܂B" << std::endl;
		return 0;
	}


	//
	deviceName = argvw[1];	//foCX
	profileName = argvw[2]; //vt@C

	//VXeXR[vw莞
	if (argcw == 4) {
		if (!wcscmp(L"/S", argvw[3])) {
			usePerUserProfiles = false;
		}
	}


	//fBXvC擾
	if (!EnumDisplayDevicesW(deviceName, 0, &displayDevice, EDD_GET_DEVICE_INTERFACE_NAME)) {
		/* G[ */
		std::wcout << "ERROR:Device Not Found" << std::endl;
		return 1;
	}


	//XR[vύX
	if (!WcsSetUsePerUserProfiles(displayDevice.DeviceKey, CLASS_MONITOR, usePerUserProfiles)) {
		/* G[*/
		std::wcout << "ERROR:WcsSetUsePerUserProfiles Failed" << std::endl;
		return 1;
	}


	//J[vt@CύX
	if (!WcsSetDefaultColorProfile(
		(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,	//WCS_PROFILE_MANAGEMENT_SCOPE_SYSTEM_WIDE=0,WCS_PROFILE_MANAGEMENT_SCOPE_CURRENT_USER=1 Ȃ̂ł̂܂܎gႤ
		displayDevice.DeviceKey,
		CPT_ICC,
		CPST_PERCEPTUAL,
		1,
		profileName
	)) {
		/* G[*/
		std::wcout << "ERROR:WcsSetDefaultColorProfile Failed" << std::endl;
		return 1;
	}


	//ȉʕ\
	//XR[v擾
	if (!WcsGetUsePerUserProfiles(displayDevice.DeviceKey, CLASS_MONITOR, &usePerUserProfiles)) {
		/* G[*/
		std::wcout << "ERROR:WcsGetUsePerUserProfiles Failed" << std::endl;
		return 1;
	}


	//J[vt@CTCY擾
	if (!WcsGetDefaultColorProfileSize(
		(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
		displayDevice.DeviceKey,
		CPT_ICC,
		CPST_PERCEPTUAL,
		1,
		&profileNameSize
	)) {
		/* G[*/
		std::wcout << "ERROR:WcsGetDefaultColorProfileSize Failed" << std::endl;
		return 1;
	}


	//J[vt@Cobt@m
	profileName = (LPWSTR)malloc(profileNameSize);
	if (profileName == NULL) {
		/* ăG[ */
		std::wcout << "ERROR:Memory Allocation Error" << std::endl;
		return 1;
	}
	else {
		//̃J[vt@C擾
		if (!WcsGetDefaultColorProfile(
			(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
			displayDevice.DeviceKey,
			CPT_ICC,
			CPST_PERCEPTUAL,
			1,
			profileNameSize,
			profileName
		)) {
			/* G[*/
			std::wcout << "ERROR:WcsGetDefaultColorProfileSize Failed" << std::endl;
			return 1;
		}
	}


	//ʕ\
	std::wcout << "DeviceName:" << deviceName << std::endl;		//foCX

	if (usePerUserProfiles)						//XR[v
		std::wcout << "Scope:User" << std::endl;
	else
		std::wcout << "Scope:System" << std::endl;

	std::wcout << "Profile:" << profileName << std::endl;		//vt@C

	return 0;
}