// GetDefaultColorProfile.cpp
// w肳ꂽfBXvC̊̃J[vt@C擾B

//CN[h
#include <stdio.h>
#include <iostream>
#include <windows.h>
#include <shellapi.h>
#include <strsafe.h>
#include <icm.h>


//C
int main()
{
	//UnicodeR}hC
	LPWSTR* argvw;
	int argcw;
	argvw = CommandLineToArgvW(GetCommandLineW(), &argcw);
	if (NULL == argvw)
	{
		std::wcout << "ERROR:CommandLineToArgvW Failed" << std::endl;
		return 1;
	}


	//ϐ錾
	DISPLAY_DEVICE displayDevice = {};				//DISPLAY_DEVICE\
	displayDevice.cb = sizeof(DISPLAY_DEVICE);			//DISPLAY_DEVICE\̂̃TCY


	LPWSTR	deviceName = (LPWSTR)L"\\\\.\\DISPLAY1";		//ΏۃfoCXij^ԍj
	BOOL	usePerUserProfiles = true;				//ΏۃfoCX̃vt@CXR[v
	DWORD	profileNameSize = 0;					//J[vt@Cobt@TCY
	LPWSTR	profileName;						//J[vt@Cobt@|C^


	//`FbN
	//ߕs͎gpo͂ďI
	if (argcw <= 1 || argcw >= 4) {
		std::wcout << "w肳ꂽfBXvC̊̃J[vt@C擾܂B" << std::endl << std::endl;
		std::wcout << "GetDefaultColorProfile.exe foCX [/S | /U]" << std::endl;
		std::wcout << "  foCX     Ώۂ̃foCXw肵܂B :\\\\.\\DISPLAY1" << std::endl;
		std::wcout << "  /S             ݂̐ݒlɂ炸AVXeŜ̐ݒ擾܂B" << std::endl;
		std::wcout << "  /U             ݂̐ݒlɂ炸A[U[Ƃ̐ݒ擾܂B" << std::endl;
		return 0;
	}


	//
	deviceName = argvw[1];	//foCX


	//fBXvC擾
	if (!EnumDisplayDevicesW(deviceName, 0, &displayDevice, EDD_GET_DEVICE_INTERFACE_NAME)) {
		/* G[ */
		std::wcout << "ERROR:Device Not Found" << std::endl;
		return 1;
	}


	//XR[vw莞
	if (argcw == 3) {
		if (!wcscmp(L"/S", argvw[2])) {
			usePerUserProfiles = false;
		}

		if (!wcscmp(L"/U", argvw[2])) {
			usePerUserProfiles = true;
		}
	}
	else {
		//XR[vw莞݂͌̐ݒl
		if (!WcsGetUsePerUserProfiles(displayDevice.DeviceKey, CLASS_MONITOR, &usePerUserProfiles)) {
			/* G[*/
			std::wcout << "ERROR:WcsGetUsePerUserProfiles Failed" << std::endl;
			return 1;
		}
	}

	//J[vt@CTCY擾
	if (!WcsGetDefaultColorProfileSize(
		(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
		displayDevice.DeviceKey,
		CPT_ICC,
		CPST_PERCEPTUAL,
		1,
		&profileNameSize
	)) {
		/* G[*/
		std::wcout << "ERROR:WcsGetDefaultColorProfileSize Failed" << std::endl;
		return 1;
	}


	//J[vt@Cobt@m
	profileName = (LPWSTR)malloc(profileNameSize);
	if (profileName == NULL) {
		/* ăG[ */
		std::wcout << "ERROR:Memory Allocation Error" << std::endl;
		return 1;
	}
	else {
		//̃J[vt@C擾
		if (!WcsGetDefaultColorProfile(
			(WCS_PROFILE_MANAGEMENT_SCOPE)usePerUserProfiles,
			displayDevice.DeviceKey,
			CPT_ICC,
			CPST_PERCEPTUAL,
			1,
			profileNameSize,
			profileName
		)) {
			/* G[*/
			std::wcout << "ERROR:WcsGetDefaultColorProfileSize Failed" << std::endl;
			return 1;
		}
	}


	//ʕ\
	std::wcout << "DeviceName:" << deviceName << std::endl;		//foCX

	if (usePerUserProfiles)						//XR[v
		std::wcout << "Scope:User" << std::endl;
	else
		std::wcout << "Scope:System" << std::endl;

	std::wcout << "Profile:" << profileName << std::endl;		//vt@C

	return 0;
}